# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from verizon.api_helper import APIHelper
from verizon.configuration import Server
from verizon.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from verizon.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from verizon.models.devices_actions_restart_response import DevicesActionsRestartResponse
from verizon.exceptions.devices_actions_restart_0_error_exception import DevicesActionsRestart0ErrorException


class DiagnosticsFactoryResetController(BaseController):

    """A Controller to access Endpoints in the verizon API."""
    def __init__(self, config):
        super(DiagnosticsFactoryResetController, self).__init__(config)

    def decives_restart(self,
                        body):
        """Does a POST request to /devices/actions/restart.

        Performs a device reboot or a factory reset on the modem portion of
        the device.

        Args:
            body (DevicesActionsRestartRequest): A request to perform a device
                reboot.

        Returns:
            DevicesActionsRestartResponse: Response from the API. Diagnostics
                observation result.

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/devices/actions/restart')
            .http_method(HttpMethodEnum.POST)
            .header_param(Parameter()
                          .key('Content-Type')
                          .value('application/json'))
            .body_param(Parameter()
                        .value(body))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .body_serializer(APIHelper.json_serialize)
            .auth(And(Single('thingspace_oauth'), Single('VZ-M2M-Token')))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(DevicesActionsRestartResponse.from_dictionary)
            .local_error('default', 'Error response.', DevicesActionsRestart0ErrorException)
        ).execute()
