# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from verizon.api_helper import APIHelper
from verizon.configuration import Server
from verizon.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from verizon.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.or_auth_group import Or
from verizon.models.m_5_gbidevice_detailsresponse import M5gbideviceDetailsresponse
from verizon.models.m_201_success import M201success
from verizon.exceptions.default_response_exception import DefaultResponseException


class M5GBIDeviceActionsController(BaseController):

    """A Controller to access Endpoints in the verizon API."""
    def __init__(self, config):
        super(M5GBIDeviceActionsController, self).__init__(config)

    def business_internetlist_device_information(self,
                                                 body):
        """Does a POST request to /actions/list.

        Uses the decive's Integrated Circuit Card Identification Number
        (ICCID) to retrive and display the device's properties.

        Args:
            body (M5gbideviceId): Device Profile Query

        Returns:
            M5gbideviceDetailsresponse: Response from the API. The device's
                details will be returned from a successful request.

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/actions/list')
            .http_method(HttpMethodEnum.POST)
            .header_param(Parameter()
                          .key('Content-Type')
                          .value('application/json'))
            .body_param(Parameter()
                        .value(body))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .body_serializer(APIHelper.json_serialize)
            .auth(Or(Single('thingspace_oauth'), Single('VZ-M2M-Token')))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(M5gbideviceDetailsresponse.from_dictionary)
            .local_error('default', 'Error response', DefaultResponseException)
        ).execute()

    def business_internetactivate_using_post(self,
                                             body):
        """Does a POST request to /actions/activate.

        Uses the device's ICCID and IMEI to activate service.

        Args:
            body (M5gbiactivateRequest): Activate 5G BI service. Defining
                <code>publicIpRestriction</code> as "Unrestricted" or
                "Restricted" is required for activating as Public Static.
                Leave  <code>publicIpRestriction</code> undefined to activate
                as Public Dynamic. Removing <code>publicIpRestriction</code>
                from the request will activate as Mobile Private Network (MPN).

        Returns:
            M201success: Response from the API. A request ID is returned as a
                successful response. Use a callback to see the details
                associated with the request ID.

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/actions/activate')
            .http_method(HttpMethodEnum.POST)
            .header_param(Parameter()
                          .key('Content-Type')
                          .value('application/json'))
            .body_param(Parameter()
                        .value(body))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .body_serializer(APIHelper.json_serialize)
            .auth(Or(Single('thingspace_oauth'), Single('VZ-M2M-Token')))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(M201success.from_dictionary)
            .local_error('default', 'Error response', DefaultResponseException)
        ).execute()

    def business_internet_serviceplanchange(self,
                                            body):
        """Does a PUT request to /actions/plan.

        Change a device's service plan to use 5G BI.

        Args:
            body (M5gbichangeRequest): This endpoint is for use when changing
                a device's service plan to a 5G BI service plan. The service
                plan can change for an active device up to four times per
                month but will require address validation for each change. The
                service plan cannot be changed for a device while its service
                is suspended.

        Returns:
            M201success: Response from the API. A request ID is returned as a
                successful response. Use a callback to see the details
                associated with the request ID.

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/actions/plan')
            .http_method(HttpMethodEnum.PUT)
            .header_param(Parameter()
                          .key('Content-Type')
                          .value('application/json'))
            .body_param(Parameter()
                        .value(body))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .body_serializer(APIHelper.json_serialize)
            .auth(Or(Single('thingspace_oauth'), Single('VZ-M2M-Token')))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(M201success.from_dictionary)
            .local_error('default', 'Error response', DefaultResponseException)
        ).execute()
