# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from verizon.api_helper import APIHelper
from verizon.configuration import Server
from verizon.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from verizon.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from verizon.models.performance_device_network_metrics_response import PerformanceDeviceNetworkMetricsResponse
from verizon.exceptions.performance_device_network_metrics_400_error_exception import PerformanceDeviceNetworkMetrics400ErrorException
from verizon.exceptions.performance_device_network_metrics_401_error_exception import PerformanceDeviceNetworkMetrics401ErrorException
from verizon.exceptions.performance_device_network_metrics_403_error_exception import PerformanceDeviceNetworkMetrics403ErrorException
from verizon.exceptions.performance_device_network_metrics_404_error_exception import PerformanceDeviceNetworkMetrics404ErrorException
from verizon.exceptions.performance_device_network_metrics_405_error_exception import PerformanceDeviceNetworkMetrics405ErrorException
from verizon.exceptions.performance_device_network_metrics_503_error_exception import PerformanceDeviceNetworkMetrics503ErrorException


class PerformanceMetricsController(BaseController):

    """A Controller to access Endpoints in the verizon API."""
    def __init__(self, config):
        super(PerformanceMetricsController, self).__init__(config)

    def query_mec_performance_metrics(self,
                                      body=None):
        """Does a POST request to /performance/device/network/metrics.

        Query the most recent data for Key Performance Indicators (KPIs) like
        network availability, MEC hostnames and more.

        Args:
            body (PerformanceDeviceNetworkMetricsRequest, optional): The
                request body parameter.

        Returns:
            PerformanceDeviceNetworkMetricsResponse: Response from the API.
                MEC performance metrics.

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/performance/device/network/metrics')
            .http_method(HttpMethodEnum.POST)
            .header_param(Parameter()
                          .key('Content-Type')
                          .value('application/json'))
            .body_param(Parameter()
                        .value(body))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .body_serializer(APIHelper.json_serialize)
            .auth(And(Single('thingspace_oauth'), Single('VZ-M2M-Token')))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(PerformanceDeviceNetworkMetricsResponse.from_dictionary)
            .local_error('400', 'Bad Request.', PerformanceDeviceNetworkMetrics400ErrorException)
            .local_error('401', 'Unauthorized request.', PerformanceDeviceNetworkMetrics401ErrorException)
            .local_error('403', 'Request forbidden.', PerformanceDeviceNetworkMetrics403ErrorException)
            .local_error('404', 'Resource Not Found.', PerformanceDeviceNetworkMetrics404ErrorException)
            .local_error('405', 'Method Not Allowed.', PerformanceDeviceNetworkMetrics405ErrorException)
            .local_error('503', 'Service Unavailable.', PerformanceDeviceNetworkMetrics503ErrorException)
        ).execute()
