# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from verizon.api_helper import APIHelper
from verizon.configuration import Server
from verizon.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from verizon.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from verizon.models.check_in_history_item import CheckInHistoryItem
from verizon.exceptions.logging_devices_check_in_history_400_error_exception import LoggingDevicesCheckInHistory400ErrorException


class ServerLoggingController(BaseController):

    """A Controller to access Endpoints in the verizon API."""
    def __init__(self, config):
        super(ServerLoggingController, self).__init__(config)

    def get_device_check_in_history(self,
                                    account,
                                    device_id):
        """Does a GET request to /logging/{account}/devices/{deviceId}/checkInHistory.

        Check-in history can be retrieved for any device belonging to the
        account, not necessarily with logging enabled.

        Args:
            account (str): Account identifier.
            device_id (str): Device IMEI identifier.

        Returns:
            List[CheckInHistoryItem]: Response from the API. List of check-in
                history entries.

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/logging/{account}/devices/{deviceId}/checkInHistory')
            .http_method(HttpMethodEnum.GET)
            .template_param(Parameter()
                            .key('account')
                            .value(account)
                            .should_encode(True))
            .template_param(Parameter()
                            .key('deviceId')
                            .value(device_id)
                            .should_encode(True))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(And(Single('thingspace_oauth'), Single('VZ-M2M-Token')))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(CheckInHistoryItem.from_dictionary)
            .local_error('400', 'Unexpected error.', LoggingDevicesCheckInHistory400ErrorException)
        ).execute()
