# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from verizon.api_helper import APIHelper
from verizon.exceptions.api_exception import APIException
from verizon.models.data_1 import Data1


class Regions400ErrorException(APIException):
    def __init__(self, reason, response):
        """Constructor for the Regions400ErrorException class

        Args:
            reason (string): The reason (or error message) for the Exception
                to be raised.
            response (HttpResponse): The HttpResponse of the API call.

        """
        super(Regions400ErrorException, self).__init__(reason, response)
        dictionary = APIHelper.json_deserialize(self.response.text)
        if isinstance(dictionary, dict):
            self.unbox(dictionary)

    def unbox(self, dictionary):
        """Populates the properties of this object by extracting them from a dictionary.

        Args:
            dictionary (dictionary): A dictionary representation of the object as
            obtained from the deserialization of the server's response. The keys
            MUST match property names in the API description.

        """
        self.status = dictionary.get("status") if dictionary.get("status") else None
        self.message = dictionary.get("message") if dictionary.get("message") else None
        self.data = Data1.from_dictionary(dictionary.get('data')) if 'data' in dictionary.keys() else None

    def __str__(self):
        base_str = super().__str__()
        return (f'{self.__class__.__name__}('
                f'{base_str[base_str.find("(") + 1:-1]}, '
                f'status={self.status!s}, '
                f'message={self.message!s}, '
                f'data={(self.data if hasattr(self, "data") else None)!s})')
