# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from verizon.api_helper import APIHelper
from verizon.exceptions.api_exception import APIException
from verizon.models.fault import Fault


class ReportSessions400ErrorException(APIException):
    def __init__(self, reason, response):
        """Constructor for the ReportSessions400ErrorException class

        Args:
            reason (string): The reason (or error message) for the Exception
                to be raised.
            response (HttpResponse): The HttpResponse of the API call.

        """
        super(ReportSessions400ErrorException, self).__init__(reason, response)
        dictionary = APIHelper.json_deserialize(self.response.text)
        if isinstance(dictionary, dict):
            self.unbox(dictionary)

    def unbox(self, dictionary):
        """Populates the properties of this object by extracting them from a dictionary.

        Args:
            dictionary (dictionary): A dictionary representation of the object as
            obtained from the deserialization of the server's response. The keys
            MUST match property names in the API description.

        """
        self.response_code = dictionary.get("responseCode") if dictionary.get("responseCode") else None
        self.message = dictionary.get("message") if dictionary.get("message") else None
        self.fault = Fault.from_dictionary(dictionary.get('fault')) if 'fault' in dictionary.keys() else None

    def __str__(self):
        base_str = super().__str__()
        return (f'{self.__class__.__name__}('
                f'{base_str[base_str.find("(") + 1:-1]}, '
                f'response_code={(self.response_code if hasattr(self, "response_code") else None)!s}, '
                f'message={(self.message if hasattr(self, "message") else None)!s}, '
                f'fault={(self.fault if hasattr(self, "fault") else None)!s})')
