# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.accountidentifier_1 import Accountidentifier1
from verizon.models.configuration_2 import Configuration2
from verizon.models.resourceidentifier_1 import Resourceidentifier1


class ChangeConfigurationRequest(object):

    """Implementation of the 'ChangeConfigurationRequest' model.

    The request body identifies the device and the values to set.

    Attributes:
        accountidentifier (Accountidentifier1): The model property of type
            Accountidentifier1.
        resourceidentifier (Resourceidentifier1): The model property of type
            Resourceidentifier1.
        configuration (Configuration2): The model property of type
            Configuration2.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "accountidentifier": 'accountidentifier',
        "resourceidentifier": 'resourceidentifier',
        "configuration": 'configuration'
    }

    _optionals = [
        'accountidentifier',
        'resourceidentifier',
        'configuration',
    ]

    def __init__(self,
                 accountidentifier=APIHelper.SKIP,
                 resourceidentifier=APIHelper.SKIP,
                 configuration=APIHelper.SKIP):
        """Constructor for the ChangeConfigurationRequest class"""

        # Initialize members of the class
        if accountidentifier is not APIHelper.SKIP:
            self.accountidentifier = accountidentifier 
        if resourceidentifier is not APIHelper.SKIP:
            self.resourceidentifier = resourceidentifier 
        if configuration is not APIHelper.SKIP:
            self.configuration = configuration 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        accountidentifier = Accountidentifier1.from_dictionary(dictionary.get('accountidentifier')) if 'accountidentifier' in dictionary.keys() else APIHelper.SKIP
        resourceidentifier = Resourceidentifier1.from_dictionary(dictionary.get('resourceidentifier')) if 'resourceidentifier' in dictionary.keys() else APIHelper.SKIP
        configuration = Configuration2.from_dictionary(dictionary.get('configuration')) if 'configuration' in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(accountidentifier,
                   resourceidentifier,
                   configuration)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'accountidentifier={(self.accountidentifier if hasattr(self, "accountidentifier") else None)!r}, '
                f'resourceidentifier={(self.resourceidentifier if hasattr(self, "resourceidentifier") else None)!r}, '
                f'configuration={(self.configuration if hasattr(self, "configuration") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'accountidentifier={(self.accountidentifier if hasattr(self, "accountidentifier") else None)!s}, '
                f'resourceidentifier={(self.resourceidentifier if hasattr(self, "resourceidentifier") else None)!s}, '
                f'configuration={(self.configuration if hasattr(self, "configuration") else None)!s})')
