# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.account_device_list import AccountDeviceList
from verizon.models.primary_place_of_use_1 import PrimaryPlaceOfUse1


class ContactInfoUpdateRequest(object):

    """Implementation of the 'ContactInfoUpdateRequest' model.

    Request to update contact information.

    Attributes:
        primary_place_of_use (PrimaryPlaceOfUse1): The model property of type
            PrimaryPlaceOfUse1.
        account_name (str): The name of the billing account that the devices
            belong to. An account name is usually numeric, and must include
            any leading zeros.
        devices (List[AccountDeviceList]): A list of the devices that you want
            to change, specified by device identifier. You only need to
            provide one identifier per device. Do not include accountName,
            groupName, customFields, or servicePlan if you use this parameter.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "primary_place_of_use": 'primaryPlaceOfUse',
        "account_name": 'accountName',
        "devices": 'devices'
    }

    _optionals = [
        'account_name',
        'devices',
    ]

    def __init__(self,
                 primary_place_of_use=None,
                 account_name=APIHelper.SKIP,
                 devices=APIHelper.SKIP):
        """Constructor for the ContactInfoUpdateRequest class"""

        # Initialize members of the class
        self.primary_place_of_use = primary_place_of_use 
        if account_name is not APIHelper.SKIP:
            self.account_name = account_name 
        if devices is not APIHelper.SKIP:
            self.devices = devices 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        primary_place_of_use = PrimaryPlaceOfUse1.from_dictionary(dictionary.get('primaryPlaceOfUse')) if dictionary.get('primaryPlaceOfUse') else None
        account_name = dictionary.get("accountName") if dictionary.get("accountName") else APIHelper.SKIP
        devices = None
        if dictionary.get('devices') is not None:
            devices = [AccountDeviceList.from_dictionary(x) for x in dictionary.get('devices')]
        else:
            devices = APIHelper.SKIP
        # Return an object of this model
        return cls(primary_place_of_use,
                   account_name,
                   devices)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'primary_place_of_use={self.primary_place_of_use!r}, '
                f'account_name={(self.account_name if hasattr(self, "account_name") else None)!r}, '
                f'devices={(self.devices if hasattr(self, "devices") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'primary_place_of_use={self.primary_place_of_use!s}, '
                f'account_name={(self.account_name if hasattr(self, "account_name") else None)!s}, '
                f'devices={(self.devices if hasattr(self, "devices") else None)!s})')
