# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.deactivate_device_list import DeactivateDeviceList


class DeactivateDeviceProfileRequest(object):

    """Implementation of the 'DeactivateDeviceProfileRequest' model.

    Attributes:
        account_name (str): The model property of type str.
        reason_code (str): The model property of type str.
        devices (List[DeactivateDeviceList]): The model property of type
            List[DeactivateDeviceList].
        carrier_name (str): The model property of type str.
        etf_waiver (bool): The model property of type bool.
        check_fallback_profile (bool): The model property of type bool.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "account_name": 'accountName',
        "reason_code": 'reasonCode',
        "devices": 'devices',
        "carrier_name": 'carrierName',
        "etf_waiver": 'etfWaiver',
        "check_fallback_profile": 'checkFallbackProfile'
    }

    _optionals = [
        'devices',
        'carrier_name',
        'etf_waiver',
        'check_fallback_profile',
    ]

    def __init__(self,
                 account_name=None,
                 reason_code=None,
                 devices=APIHelper.SKIP,
                 carrier_name=APIHelper.SKIP,
                 etf_waiver=True,
                 check_fallback_profile=False):
        """Constructor for the DeactivateDeviceProfileRequest class"""

        # Initialize members of the class
        self.account_name = account_name 
        self.reason_code = reason_code 
        if devices is not APIHelper.SKIP:
            self.devices = devices 
        if carrier_name is not APIHelper.SKIP:
            self.carrier_name = carrier_name 
        self.etf_waiver = etf_waiver 
        self.check_fallback_profile = check_fallback_profile 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        account_name = dictionary.get("accountName") if dictionary.get("accountName") else None
        reason_code = dictionary.get("reasonCode") if dictionary.get("reasonCode") else None
        devices = None
        if dictionary.get('devices') is not None:
            devices = [DeactivateDeviceList.from_dictionary(x) for x in dictionary.get('devices')]
        else:
            devices = APIHelper.SKIP
        carrier_name = dictionary.get("carrierName") if dictionary.get("carrierName") else APIHelper.SKIP
        etf_waiver = dictionary.get("etfWaiver") if dictionary.get("etfWaiver") else True
        check_fallback_profile = dictionary.get("checkFallbackProfile") if dictionary.get("checkFallbackProfile") else False
        # Return an object of this model
        return cls(account_name,
                   reason_code,
                   devices,
                   carrier_name,
                   etf_waiver,
                   check_fallback_profile)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'account_name={self.account_name!r}, '
                f'reason_code={self.reason_code!r}, '
                f'devices={(self.devices if hasattr(self, "devices") else None)!r}, '
                f'carrier_name={(self.carrier_name if hasattr(self, "carrier_name") else None)!r}, '
                f'etf_waiver={(self.etf_waiver if hasattr(self, "etf_waiver") else None)!r}, '
                f'check_fallback_profile={(self.check_fallback_profile if hasattr(self, "check_fallback_profile") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'account_name={self.account_name!s}, '
                f'reason_code={self.reason_code!s}, '
                f'devices={(self.devices if hasattr(self, "devices") else None)!s}, '
                f'carrier_name={(self.carrier_name if hasattr(self, "carrier_name") else None)!s}, '
                f'etf_waiver={(self.etf_waiver if hasattr(self, "etf_waiver") else None)!s}, '
                f'check_fallback_profile={(self.check_fallback_profile if hasattr(self, "check_fallback_profile") else None)!s})')
