# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""


class DeviceDiagnosticsResult(object):

    """Implementation of the 'DeviceDiagnosticsResult' model.

    All error messages are returned in this format. Error codes and messages
    are listed on the Error Codes page, along with explanations and
    suggestions for corrective actions.

    Attributes:
        error_code (str): Simple error code.
        error_message (str): Detailed error message.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "error_code": 'errorCode',
        "error_message": 'errorMessage'
    }

    def __init__(self,
                 error_code=None,
                 error_message=None):
        """Constructor for the DeviceDiagnosticsResult class"""

        # Initialize members of the class
        self.error_code = error_code 
        self.error_message = error_message 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        error_code = dictionary.get("errorCode") if dictionary.get("errorCode") else None
        error_message = dictionary.get("errorMessage") if dictionary.get("errorMessage") else None
        # Return an object of this model
        return cls(error_code,
                   error_message)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'error_code={self.error_code!r}, '
                f'error_message={self.error_message!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'error_code={self.error_code!s}, '
                f'error_message={self.error_message!s})')
