# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.models.device_service_request import DeviceServiceRequest


class DevicesServicesRequest(object):

    """Implementation of the 'Devices Services Request' model.

    Attributes:
        device_list (List[DeviceServiceRequest]): A list of devices.
        account_number (str): A unique identifier for an account.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "device_list": 'deviceList',
        "account_number": 'accountNumber'
    }

    def __init__(self,
                 device_list=None,
                 account_number=None):
        """Constructor for the DevicesServicesRequest class"""

        # Initialize members of the class
        self.device_list = device_list 
        self.account_number = account_number 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        device_list = None
        if dictionary.get('deviceList') is not None:
            device_list = [DeviceServiceRequest.from_dictionary(x) for x in dictionary.get('deviceList')]
        account_number = dictionary.get("accountNumber") if dictionary.get("accountNumber") else None
        # Return an object of this model
        return cls(device_list,
                   account_number)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'device_list={self.device_list!r}, '
                f'account_number={self.account_number!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'device_list={self.device_list!s}, '
                f'account_number={self.account_number!s})')
