# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.dto_health_score_metric import DtoHealthScoreMetric


class DtoGetNetworkHealthScoreResponse(object):

    """Implementation of the 'dto.GetNetworkHealthScoreResponse' model.

    The values measured are for the network

    Attributes:
        networksummary (List[DtoHealthScoreMetric]): The model property of
            type List[DtoHealthScoreMetric].
        overallsummary (List[DtoHealthScoreMetric]): The model property of
            type List[DtoHealthScoreMetric].

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "networksummary": 'networksummary',
        "overallsummary": 'overallsummary'
    }

    _optionals = [
        'networksummary',
        'overallsummary',
    ]

    def __init__(self,
                 networksummary=APIHelper.SKIP,
                 overallsummary=APIHelper.SKIP):
        """Constructor for the DtoGetNetworkHealthScoreResponse class"""

        # Initialize members of the class
        if networksummary is not APIHelper.SKIP:
            self.networksummary = networksummary 
        if overallsummary is not APIHelper.SKIP:
            self.overallsummary = overallsummary 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        networksummary = None
        if dictionary.get('networksummary') is not None:
            networksummary = [DtoHealthScoreMetric.from_dictionary(x) for x in dictionary.get('networksummary')]
        else:
            networksummary = APIHelper.SKIP
        overallsummary = None
        if dictionary.get('overallsummary') is not None:
            overallsummary = [DtoHealthScoreMetric.from_dictionary(x) for x in dictionary.get('overallsummary')]
        else:
            overallsummary = APIHelper.SKIP
        # Return an object of this model
        return cls(networksummary,
                   overallsummary)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'networksummary={(self.networksummary if hasattr(self, "networksummary") else None)!r}, '
                f'overallsummary={(self.overallsummary if hasattr(self, "overallsummary") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'networksummary={(self.networksummary if hasattr(self, "networksummary") else None)!s}, '
                f'overallsummary={(self.overallsummary if hasattr(self, "overallsummary") else None)!s})')
