# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.resource_device import ResourceDevice
from verizon.models.resourceidentifier_9 import Resourceidentifier9


class DtoPatchDeviceRequest(object):

    """Implementation of the 'dto.PatchDeviceRequest' model.

    Attributes:
        accountname (str): The numeric account name, which must include
            leading zeros
        device (ResourceDevice): The model property of type ResourceDevice.
        resourceidentifier (Resourceidentifier9): The model property of type
            Resourceidentifier9.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "accountname": 'accountname',
        "device": 'device',
        "resourceidentifier": 'resourceidentifier'
    }

    _optionals = [
        'accountname',
        'device',
        'resourceidentifier',
    ]

    def __init__(self,
                 accountname=APIHelper.SKIP,
                 device=APIHelper.SKIP,
                 resourceidentifier=APIHelper.SKIP):
        """Constructor for the DtoPatchDeviceRequest class"""

        # Initialize members of the class
        if accountname is not APIHelper.SKIP:
            self.accountname = accountname 
        if device is not APIHelper.SKIP:
            self.device = device 
        if resourceidentifier is not APIHelper.SKIP:
            self.resourceidentifier = resourceidentifier 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        accountname = dictionary.get("accountname") if dictionary.get("accountname") else APIHelper.SKIP
        device = ResourceDevice.from_dictionary(dictionary.get('device')) if 'device' in dictionary.keys() else APIHelper.SKIP
        resourceidentifier = Resourceidentifier9.from_dictionary(dictionary.get('resourceidentifier')) if 'resourceidentifier' in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(accountname,
                   device,
                   resourceidentifier)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'accountname={(self.accountname if hasattr(self, "accountname") else None)!r}, '
                f'device={(self.device if hasattr(self, "device") else None)!r}, '
                f'resourceidentifier={(self.resourceidentifier if hasattr(self, "resourceidentifier") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'accountname={(self.accountname if hasattr(self, "accountname") else None)!s}, '
                f'device={(self.device if hasattr(self, "device") else None)!s}, '
                f'resourceidentifier={(self.resourceidentifier if hasattr(self, "resourceidentifier") else None)!s})')
