# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.dto_resourceidentifier import DtoResourceidentifier
from verizon.models.user_smart_alert import UserSmartAlert


class DtoPatchSmartAlertRequest(object):

    """Implementation of the 'dto.PatchSmartAlertRequest' model.

    Attributes:
        accountname (str): The numeric account name, which must include
            leading zeros
        resourceidentifier (DtoResourceidentifier): The model property of type
            DtoResourceidentifier.
        smartalert (UserSmartAlert): The model property of type UserSmartAlert.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "accountname": 'accountname',
        "resourceidentifier": 'resourceidentifier',
        "smartalert": 'smartalert'
    }

    _optionals = [
        'accountname',
        'resourceidentifier',
        'smartalert',
    ]

    def __init__(self,
                 accountname=APIHelper.SKIP,
                 resourceidentifier=APIHelper.SKIP,
                 smartalert=APIHelper.SKIP):
        """Constructor for the DtoPatchSmartAlertRequest class"""

        # Initialize members of the class
        if accountname is not APIHelper.SKIP:
            self.accountname = accountname 
        if resourceidentifier is not APIHelper.SKIP:
            self.resourceidentifier = resourceidentifier 
        if smartalert is not APIHelper.SKIP:
            self.smartalert = smartalert 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        accountname = dictionary.get("accountname") if dictionary.get("accountname") else APIHelper.SKIP
        resourceidentifier = DtoResourceidentifier.from_dictionary(dictionary.get('resourceidentifier')) if 'resourceidentifier' in dictionary.keys() else APIHelper.SKIP
        smartalert = UserSmartAlert.from_dictionary(dictionary.get('smartalert')) if 'smartalert' in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(accountname,
                   resourceidentifier,
                   smartalert)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'accountname={(self.accountname if hasattr(self, "accountname") else None)!r}, '
                f'resourceidentifier={(self.resourceidentifier if hasattr(self, "resourceidentifier") else None)!r}, '
                f'smartalert={(self.smartalert if hasattr(self, "smartalert") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'accountname={(self.accountname if hasattr(self, "accountname") else None)!s}, '
                f'resourceidentifier={(self.resourceidentifier if hasattr(self, "resourceidentifier") else None)!s}, '
                f'smartalert={(self.smartalert if hasattr(self, "smartalert") else None)!s})')
