# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.fields_4 import Fields4


class DtoSensorBoardingEvent(object):

    """Implementation of the 'dto.SensorBoardingEvent' model.

    Attributes:
        createdon (datetime): Timestamp of the record
        errmsg (str): Error message
        fields (Fields4): The model property of type Fields4.
        state (str): The current status of the device or transaction and will
            be `success` or `failed`
        transactionid (str): The system-generated UUID of the transaction

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "createdon": 'createdon',
        "errmsg": 'errmsg',
        "fields": 'fields',
        "state": 'state',
        "transactionid": 'transactionid'
    }

    _optionals = [
        'createdon',
        'errmsg',
        'fields',
        'state',
        'transactionid',
    ]

    def __init__(self,
                 createdon=APIHelper.SKIP,
                 errmsg=APIHelper.SKIP,
                 fields=APIHelper.SKIP,
                 state=APIHelper.SKIP,
                 transactionid=APIHelper.SKIP):
        """Constructor for the DtoSensorBoardingEvent class"""

        # Initialize members of the class
        if createdon is not APIHelper.SKIP:
            self.createdon = APIHelper.apply_datetime_converter(createdon, APIHelper.RFC3339DateTime) if createdon else None 
        if errmsg is not APIHelper.SKIP:
            self.errmsg = errmsg 
        if fields is not APIHelper.SKIP:
            self.fields = fields 
        if state is not APIHelper.SKIP:
            self.state = state 
        if transactionid is not APIHelper.SKIP:
            self.transactionid = transactionid 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        createdon = APIHelper.RFC3339DateTime.from_value(dictionary.get("createdon")).datetime if dictionary.get("createdon") else APIHelper.SKIP
        errmsg = dictionary.get("errmsg") if dictionary.get("errmsg") else APIHelper.SKIP
        fields = Fields4.from_dictionary(dictionary.get('fields')) if 'fields' in dictionary.keys() else APIHelper.SKIP
        state = dictionary.get("state") if dictionary.get("state") else APIHelper.SKIP
        transactionid = dictionary.get("transactionid") if dictionary.get("transactionid") else APIHelper.SKIP
        # Return an object of this model
        return cls(createdon,
                   errmsg,
                   fields,
                   state,
                   transactionid)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'createdon={(self.createdon if hasattr(self, "createdon") else None)!r}, '
                f'errmsg={(self.errmsg if hasattr(self, "errmsg") else None)!r}, '
                f'fields={(self.fields if hasattr(self, "fields") else None)!r}, '
                f'state={(self.state if hasattr(self, "state") else None)!r}, '
                f'transactionid={(self.transactionid if hasattr(self, "transactionid") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'createdon={(self.createdon if hasattr(self, "createdon") else None)!s}, '
                f'errmsg={(self.errmsg if hasattr(self, "errmsg") else None)!s}, '
                f'fields={(self.fields if hasattr(self, "fields") else None)!s}, '
                f'state={(self.state if hasattr(self, "state") else None)!s}, '
                f'transactionid={(self.transactionid if hasattr(self, "transactionid") else None)!s})')
