# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.gatewayidentifier import Gatewayidentifier
from verizon.models.offboarding import Offboarding


class DtoSensorOffBoardStatusRequest(object):

    """Implementation of the 'dto.SensorOffBoardStatusRequest' model.

    Attributes:
        accountname (str): The numeric account name, which must include
            leading zeros
        gatewayidentifier (Gatewayidentifier): The model property of type
            Gatewayidentifier.
        offboarding (Offboarding): The model property of type Offboarding.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "accountname": 'accountname',
        "gatewayidentifier": 'gatewayidentifier',
        "offboarding": 'offboarding'
    }

    _optionals = [
        'accountname',
        'gatewayidentifier',
        'offboarding',
    ]

    def __init__(self,
                 accountname=APIHelper.SKIP,
                 gatewayidentifier=APIHelper.SKIP,
                 offboarding=APIHelper.SKIP):
        """Constructor for the DtoSensorOffBoardStatusRequest class"""

        # Initialize members of the class
        if accountname is not APIHelper.SKIP:
            self.accountname = accountname 
        if gatewayidentifier is not APIHelper.SKIP:
            self.gatewayidentifier = gatewayidentifier 
        if offboarding is not APIHelper.SKIP:
            self.offboarding = offboarding 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        accountname = dictionary.get("accountname") if dictionary.get("accountname") else APIHelper.SKIP
        gatewayidentifier = Gatewayidentifier.from_dictionary(dictionary.get('gatewayidentifier')) if 'gatewayidentifier' in dictionary.keys() else APIHelper.SKIP
        offboarding = Offboarding.from_dictionary(dictionary.get('offboarding')) if 'offboarding' in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(accountname,
                   gatewayidentifier,
                   offboarding)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'accountname={(self.accountname if hasattr(self, "accountname") else None)!r}, '
                f'gatewayidentifier={(self.gatewayidentifier if hasattr(self, "gatewayidentifier") else None)!r}, '
                f'offboarding={(self.offboarding if hasattr(self, "offboarding") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'accountname={(self.accountname if hasattr(self, "accountname") else None)!s}, '
                f'gatewayidentifier={(self.gatewayidentifier if hasattr(self, "gatewayidentifier") else None)!s}, '
                f'offboarding={(self.offboarding if hasattr(self, "offboarding") else None)!s})')
