# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.dto_user_dto import DtoUserDTO


class DtoUpdateUserRequest(object):

    """Implementation of the 'dto.UpdateUserRequest' model.

    Attributes:
        accountname (str): The numeric account name, which must include
            leading zeros
        id (str): UUID of the user record, assigned at creation
        user (DtoUserDTO): The model property of type DtoUserDTO.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "accountname": 'accountname',
        "id": 'id',
        "user": 'user'
    }

    _optionals = [
        'accountname',
        'id',
        'user',
    ]

    def __init__(self,
                 accountname=APIHelper.SKIP,
                 id=APIHelper.SKIP,
                 user=APIHelper.SKIP):
        """Constructor for the DtoUpdateUserRequest class"""

        # Initialize members of the class
        if accountname is not APIHelper.SKIP:
            self.accountname = accountname 
        if id is not APIHelper.SKIP:
            self.id = id 
        if user is not APIHelper.SKIP:
            self.user = user 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        accountname = dictionary.get("accountname") if dictionary.get("accountname") else APIHelper.SKIP
        id = dictionary.get("id") if dictionary.get("id") else APIHelper.SKIP
        user = DtoUserDTO.from_dictionary(dictionary.get('user')) if 'user' in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(accountname,
                   id,
                   user)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'accountname={(self.accountname if hasattr(self, "accountname") else None)!r}, '
                f'id={(self.id if hasattr(self, "id") else None)!r}, '
                f'user={(self.user if hasattr(self, "user") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'accountname={(self.accountname if hasattr(self, "accountname") else None)!s}, '
                f'id={(self.id if hasattr(self, "id") else None)!s}, '
                f'user={(self.user if hasattr(self, "user") else None)!s})')
