# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.esim_device_list import ESIMDeviceList


class ESIMProfileRequest(object):

    """Implementation of the 'eSIMProfileRequest' model.

    Attributes:
        devices (List[ESIMDeviceList]): The model property of type
            List[ESIMDeviceList].
        carrier_name (str): The model property of type str.
        account_name (str): The model property of type str.
        service_plan (str): The model property of type str.
        mdn_zip_code (str): The model property of type str.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "devices": 'devices',
        "carrier_name": 'carrierName',
        "account_name": 'accountName',
        "service_plan": 'servicePlan',
        "mdn_zip_code": 'mdnZipCode'
    }

    _optionals = [
        'devices',
        'carrier_name',
        'account_name',
        'service_plan',
        'mdn_zip_code',
    ]

    def __init__(self,
                 devices=APIHelper.SKIP,
                 carrier_name=APIHelper.SKIP,
                 account_name=APIHelper.SKIP,
                 service_plan=APIHelper.SKIP,
                 mdn_zip_code=APIHelper.SKIP):
        """Constructor for the ESIMProfileRequest class"""

        # Initialize members of the class
        if devices is not APIHelper.SKIP:
            self.devices = devices 
        if carrier_name is not APIHelper.SKIP:
            self.carrier_name = carrier_name 
        if account_name is not APIHelper.SKIP:
            self.account_name = account_name 
        if service_plan is not APIHelper.SKIP:
            self.service_plan = service_plan 
        if mdn_zip_code is not APIHelper.SKIP:
            self.mdn_zip_code = mdn_zip_code 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        devices = None
        if dictionary.get('devices') is not None:
            devices = [ESIMDeviceList.from_dictionary(x) for x in dictionary.get('devices')]
        else:
            devices = APIHelper.SKIP
        carrier_name = dictionary.get("carrierName") if dictionary.get("carrierName") else APIHelper.SKIP
        account_name = dictionary.get("accountName") if dictionary.get("accountName") else APIHelper.SKIP
        service_plan = dictionary.get("servicePlan") if dictionary.get("servicePlan") else APIHelper.SKIP
        mdn_zip_code = dictionary.get("mdnZipCode") if dictionary.get("mdnZipCode") else APIHelper.SKIP
        # Return an object of this model
        return cls(devices,
                   carrier_name,
                   account_name,
                   service_plan,
                   mdn_zip_code)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'devices={(self.devices if hasattr(self, "devices") else None)!r}, '
                f'carrier_name={(self.carrier_name if hasattr(self, "carrier_name") else None)!r}, '
                f'account_name={(self.account_name if hasattr(self, "account_name") else None)!r}, '
                f'service_plan={(self.service_plan if hasattr(self, "service_plan") else None)!r}, '
                f'mdn_zip_code={(self.mdn_zip_code if hasattr(self, "mdn_zip_code") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'devices={(self.devices if hasattr(self, "devices") else None)!s}, '
                f'carrier_name={(self.carrier_name if hasattr(self, "carrier_name") else None)!s}, '
                f'account_name={(self.account_name if hasattr(self, "account_name") else None)!s}, '
                f'service_plan={(self.service_plan if hasattr(self, "service_plan") else None)!s}, '
                f'mdn_zip_code={(self.mdn_zip_code if hasattr(self, "mdn_zip_code") else None)!s})')
