# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.geo_fence_1 import GeoFence1


class GeoFenceConfigurationResponse(object):

    """Implementation of the 'GeoFenceConfigurationResponse' model.

    Response for /api/v1/application/configurations/geofence endpoint. It
    provides a response if the configuration was created and saved in the
    system.

    Attributes:
        id (str): The generated ID (UUID v4) for the configuration. It has to
            be used when asking for changing any of the configuration
            parameters.
        vendor_id (str): The vendor that the configuration belongs to. E.g.
            Verizon, GM, Ford, etc.
        name (str): Name of the configuration.
        description (str): Description of the configuration.
        geo_fence (GeoFence1): The model property of type GeoFence1.
        messages (List[Any]): List of predefined messages that belongs to the
            geofence. These are the messages that are sent out by the system
            when the Trigger Condition for the message is met.
        is_active (bool): The model property of type bool.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "id": 'id',
        "vendor_id": 'vendorId',
        "geo_fence": 'geoFence',
        "messages": 'messages',
        "is_active": 'isActive',
        "name": 'name',
        "description": 'description'
    }

    _optionals = [
        'name',
        'description',
    ]

    def __init__(self,
                 id=None,
                 vendor_id=None,
                 geo_fence=None,
                 messages=None,
                 is_active=None,
                 name=APIHelper.SKIP,
                 description=APIHelper.SKIP):
        """Constructor for the GeoFenceConfigurationResponse class"""

        # Initialize members of the class
        self.id = id 
        self.vendor_id = vendor_id 
        if name is not APIHelper.SKIP:
            self.name = name 
        if description is not APIHelper.SKIP:
            self.description = description 
        self.geo_fence = geo_fence 
        self.messages = messages 
        self.is_active = is_active 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        id = dictionary.get("id") if dictionary.get("id") else None
        vendor_id = dictionary.get("vendorId") if dictionary.get("vendorId") else None
        geo_fence = GeoFence1.from_dictionary(dictionary.get('geoFence')) if dictionary.get('geoFence') else None
        messages = dictionary.get("messages") if dictionary.get("messages") else None
        is_active = dictionary.get("isActive") if "isActive" in dictionary.keys() else None
        name = dictionary.get("name") if dictionary.get("name") else APIHelper.SKIP
        description = dictionary.get("description") if dictionary.get("description") else APIHelper.SKIP
        # Return an object of this model
        return cls(id,
                   vendor_id,
                   geo_fence,
                   messages,
                   is_active,
                   name,
                   description)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'id={self.id!r}, '
                f'vendor_id={self.vendor_id!r}, '
                f'name={(self.name if hasattr(self, "name") else None)!r}, '
                f'description={(self.description if hasattr(self, "description") else None)!r}, '
                f'geo_fence={self.geo_fence!r}, '
                f'messages={self.messages!r}, '
                f'is_active={self.is_active!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'id={self.id!s}, '
                f'vendor_id={self.vendor_id!s}, '
                f'name={(self.name if hasattr(self, "name") else None)!s}, '
                f'description={(self.description if hasattr(self, "description") else None)!s}, '
                f'geo_fence={self.geo_fence!s}, '
                f'messages={self.messages!s}, '
                f'is_active={self.is_active!s})')
