# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.gio_device_list import GIODeviceList


class GIOProfileRequest(object):

    """Implementation of the 'GIOProfileRequest' model.

    Attributes:
        devices (List[GIODeviceList]): The model property of type
            List[GIODeviceList].
        account_name (str): The model property of type str.
        mdn_zip_code (str): The model property of type str.
        service_plan (str): The model property of type str.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "devices": 'devices',
        "account_name": 'accountName',
        "mdn_zip_code": 'mdnZipCode',
        "service_plan": 'servicePlan'
    }

    _optionals = [
        'mdn_zip_code',
        'service_plan',
    ]

    def __init__(self,
                 devices=None,
                 account_name=None,
                 mdn_zip_code=APIHelper.SKIP,
                 service_plan=APIHelper.SKIP):
        """Constructor for the GIOProfileRequest class"""

        # Initialize members of the class
        self.devices = devices 
        self.account_name = account_name 
        if mdn_zip_code is not APIHelper.SKIP:
            self.mdn_zip_code = mdn_zip_code 
        if service_plan is not APIHelper.SKIP:
            self.service_plan = service_plan 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        devices = None
        if dictionary.get('devices') is not None:
            devices = [GIODeviceList.from_dictionary(x) for x in dictionary.get('devices')]
        account_name = dictionary.get("accountName") if dictionary.get("accountName") else None
        mdn_zip_code = dictionary.get("mdnZipCode") if dictionary.get("mdnZipCode") else APIHelper.SKIP
        service_plan = dictionary.get("servicePlan") if dictionary.get("servicePlan") else APIHelper.SKIP
        # Return an object of this model
        return cls(devices,
                   account_name,
                   mdn_zip_code,
                   service_plan)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'devices={self.devices!r}, '
                f'account_name={self.account_name!r}, '
                f'mdn_zip_code={(self.mdn_zip_code if hasattr(self, "mdn_zip_code") else None)!r}, '
                f'service_plan={(self.service_plan if hasattr(self, "service_plan") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'devices={self.devices!s}, '
                f'account_name={self.account_name!s}, '
                f'mdn_zip_code={(self.mdn_zip_code if hasattr(self, "mdn_zip_code") else None)!s}, '
                f'service_plan={(self.service_plan if hasattr(self, "service_plan") else None)!s})')
