# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.gio_device_id import GIODeviceId


class GIOSmsMessage(object):

    """Implementation of the 'GIOSmsMessage' model.

    Attributes:
        device_ids (List[GIODeviceId]): The model property of type
            List[GIODeviceId].
        message (str): The model property of type str.
        timestamp (datetime): The model property of type datetime.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "device_ids": 'deviceIds',
        "message": 'message',
        "timestamp": 'timestamp'
    }

    _optionals = [
        'device_ids',
        'message',
        'timestamp',
    ]

    def __init__(self,
                 device_ids=APIHelper.SKIP,
                 message=APIHelper.SKIP,
                 timestamp=APIHelper.SKIP):
        """Constructor for the GIOSmsMessage class"""

        # Initialize members of the class
        if device_ids is not APIHelper.SKIP:
            self.device_ids = device_ids 
        if message is not APIHelper.SKIP:
            self.message = message 
        if timestamp is not APIHelper.SKIP:
            self.timestamp = APIHelper.apply_datetime_converter(timestamp, APIHelper.RFC3339DateTime) if timestamp else None 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        device_ids = None
        if dictionary.get('deviceIds') is not None:
            device_ids = [GIODeviceId.from_dictionary(x) for x in dictionary.get('deviceIds')]
        else:
            device_ids = APIHelper.SKIP
        message = dictionary.get("message") if dictionary.get("message") else APIHelper.SKIP
        timestamp = APIHelper.RFC3339DateTime.from_value(dictionary.get("timestamp")).datetime if dictionary.get("timestamp") else APIHelper.SKIP
        # Return an object of this model
        return cls(device_ids,
                   message,
                   timestamp)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'device_ids={(self.device_ids if hasattr(self, "device_ids") else None)!r}, '
                f'message={(self.message if hasattr(self, "message") else None)!r}, '
                f'timestamp={(self.timestamp if hasattr(self, "timestamp") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'device_ids={(self.device_ids if hasattr(self, "device_ids") else None)!s}, '
                f'message={(self.message if hasattr(self, "message") else None)!s}, '
                f'timestamp={(self.timestamp if hasattr(self, "timestamp") else None)!s})')
