# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper


class Headers(object):

    """Implementation of the 'Headers' model.

    Attributes:
        authorization (str): Authorization header.
        content_type (str): Content-Type header.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "authorization": 'Authorization',
        "content_type": 'Content-Type'
    }

    _optionals = [
        'authorization',
        'content_type',
    ]

    def __init__(self,
                 authorization=APIHelper.SKIP,
                 content_type=APIHelper.SKIP):
        """Constructor for the Headers class"""

        # Initialize members of the class
        if authorization is not APIHelper.SKIP:
            self.authorization = authorization 
        if content_type is not APIHelper.SKIP:
            self.content_type = content_type 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        authorization = dictionary.get("Authorization") if dictionary.get("Authorization") else APIHelper.SKIP
        content_type = dictionary.get("Content-Type") if dictionary.get("Content-Type") else APIHelper.SKIP
        # Return an object of this model
        return cls(authorization,
                   content_type)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'authorization={(self.authorization if hasattr(self, "authorization") else None)!r}, '
                f'content_type={(self.content_type if hasattr(self, "content_type") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'authorization={(self.authorization if hasattr(self, "authorization") else None)!s}, '
                f'content_type={(self.content_type if hasattr(self, "content_type") else None)!s})')
