# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""


class HeadingItem(object):

    """Implementation of the 'HeadingItem' model.

    Heading limitation provides minimum and maximum value for road user
    heading in unit of degrees. If the road user's heading value is between
    the given minimum and maximum value and the TriggerConditions are also met
    the message will be sent out.
    The heading minimum value can be bigger than the maximum value as negative
    number are not supported. For example, the +/- 10 degrees around the north
    (0 degrees) can be defined as 350 (min) to 10 (max) degrees.

    Attributes:
        heading (Any): The model property of type Any.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "heading": 'heading'
    }

    def __init__(self,
                 heading=None):
        """Constructor for the HeadingItem class"""

        # Initialize members of the class
        self.heading = heading 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        heading = dictionary.get("heading") if dictionary.get("heading") else None
        # Return an object of this model
        return cls(heading)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'heading={self.heading!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'heading={self.heading!s})')
