# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper


class ManagedAccountsProvisionResponse(object):

    """Implementation of the 'ManagedAccountsProvisionResponse' model.

    Attributes:
        txid (str): Transaction identifier
        account_name (str): Account identifier
        paccount_name (str): Primary Account identifier
        service_name (ServiceNameEnum): The model property of type
            ServiceNameEnum.
        status (str): Provision status. Success or Fail
        reason (str): Detailed reason

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "txid": 'txid',
        "account_name": 'accountName',
        "paccount_name": 'paccountName',
        "service_name": 'serviceName',
        "status": 'status',
        "reason": 'reason'
    }

    _optionals = [
        'txid',
        'account_name',
        'paccount_name',
        'service_name',
        'status',
        'reason',
    ]

    def __init__(self,
                 txid=APIHelper.SKIP,
                 account_name=APIHelper.SKIP,
                 paccount_name=APIHelper.SKIP,
                 service_name=APIHelper.SKIP,
                 status=APIHelper.SKIP,
                 reason=APIHelper.SKIP):
        """Constructor for the ManagedAccountsProvisionResponse class"""

        # Initialize members of the class
        if txid is not APIHelper.SKIP:
            self.txid = txid 
        if account_name is not APIHelper.SKIP:
            self.account_name = account_name 
        if paccount_name is not APIHelper.SKIP:
            self.paccount_name = paccount_name 
        if service_name is not APIHelper.SKIP:
            self.service_name = service_name 
        if status is not APIHelper.SKIP:
            self.status = status 
        if reason is not APIHelper.SKIP:
            self.reason = reason 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        txid = dictionary.get("txid") if dictionary.get("txid") else APIHelper.SKIP
        account_name = dictionary.get("accountName") if dictionary.get("accountName") else APIHelper.SKIP
        paccount_name = dictionary.get("paccountName") if dictionary.get("paccountName") else APIHelper.SKIP
        service_name = dictionary.get("serviceName") if dictionary.get("serviceName") else APIHelper.SKIP
        status = dictionary.get("status") if dictionary.get("status") else APIHelper.SKIP
        reason = dictionary.get("reason") if dictionary.get("reason") else APIHelper.SKIP
        # Return an object of this model
        return cls(txid,
                   account_name,
                   paccount_name,
                   service_name,
                   status,
                   reason)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'txid={(self.txid if hasattr(self, "txid") else None)!r}, '
                f'account_name={(self.account_name if hasattr(self, "account_name") else None)!r}, '
                f'paccount_name={(self.paccount_name if hasattr(self, "paccount_name") else None)!r}, '
                f'service_name={(self.service_name if hasattr(self, "service_name") else None)!r}, '
                f'status={(self.status if hasattr(self, "status") else None)!r}, '
                f'reason={(self.reason if hasattr(self, "reason") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'txid={(self.txid if hasattr(self, "txid") else None)!s}, '
                f'account_name={(self.account_name if hasattr(self, "account_name") else None)!s}, '
                f'paccount_name={(self.paccount_name if hasattr(self, "paccount_name") else None)!s}, '
                f'service_name={(self.service_name if hasattr(self, "service_name") else None)!s}, '
                f'status={(self.status if hasattr(self, "status") else None)!s}, '
                f'reason={(self.reason if hasattr(self, "reason") else None)!s})')
