# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper


class Pd(object):

    """Implementation of the 'Pd' model.

    Attributes:
        time (str): Time location obtained.
        utcoffset (str): UTC offset of time.
        x (str): X coordinate of location.
        y (str): Y coordinate of location.
        radius (str): Radius of the location in meters.
        qos (bool): Whether requested accurary is met or not.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "time": 'time',
        "utcoffset": 'utcoffset',
        "x": 'x',
        "y": 'y',
        "radius": 'radius',
        "qos": 'qos'
    }

    _optionals = [
        'time',
        'utcoffset',
        'x',
        'y',
        'radius',
        'qos',
    ]

    def __init__(self,
                 time=APIHelper.SKIP,
                 utcoffset=APIHelper.SKIP,
                 x=APIHelper.SKIP,
                 y=APIHelper.SKIP,
                 radius=APIHelper.SKIP,
                 qos=APIHelper.SKIP):
        """Constructor for the Pd class"""

        # Initialize members of the class
        if time is not APIHelper.SKIP:
            self.time = time 
        if utcoffset is not APIHelper.SKIP:
            self.utcoffset = utcoffset 
        if x is not APIHelper.SKIP:
            self.x = x 
        if y is not APIHelper.SKIP:
            self.y = y 
        if radius is not APIHelper.SKIP:
            self.radius = radius 
        if qos is not APIHelper.SKIP:
            self.qos = qos 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        time = dictionary.get("time") if dictionary.get("time") else APIHelper.SKIP
        utcoffset = dictionary.get("utcoffset") if dictionary.get("utcoffset") else APIHelper.SKIP
        x = dictionary.get("x") if dictionary.get("x") else APIHelper.SKIP
        y = dictionary.get("y") if dictionary.get("y") else APIHelper.SKIP
        radius = dictionary.get("radius") if dictionary.get("radius") else APIHelper.SKIP
        qos = dictionary.get("qos") if "qos" in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(time,
                   utcoffset,
                   x,
                   y,
                   radius,
                   qos)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'time={(self.time if hasattr(self, "time") else None)!r}, '
                f'utcoffset={(self.utcoffset if hasattr(self, "utcoffset") else None)!r}, '
                f'x={(self.x if hasattr(self, "x") else None)!r}, '
                f'y={(self.y if hasattr(self, "y") else None)!r}, '
                f'radius={(self.radius if hasattr(self, "radius") else None)!r}, '
                f'qos={(self.qos if hasattr(self, "qos") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'time={(self.time if hasattr(self, "time") else None)!s}, '
                f'utcoffset={(self.utcoffset if hasattr(self, "utcoffset") else None)!s}, '
                f'x={(self.x if hasattr(self, "x") else None)!s}, '
                f'y={(self.y if hasattr(self, "y") else None)!s}, '
                f'radius={(self.radius if hasattr(self, "radius") else None)!s}, '
                f'qos={(self.qos if hasattr(self, "qos") else None)!s})')
