# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.models.device_list import DeviceList


class ProfileChangeStateRequest(object):

    """Implementation of the 'ProfileChangeStateRequest' model.

    Attributes:
        devices (List[DeviceList]): The model property of type
            List[DeviceList].
        account_name (str): The model property of type str.
        smsr_oid (str): The model property of type str.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "devices": 'devices',
        "account_name": 'accountName',
        "smsr_oid": 'smsrOid'
    }

    def __init__(self,
                 devices=None,
                 account_name=None,
                 smsr_oid=None):
        """Constructor for the ProfileChangeStateRequest class"""

        # Initialize members of the class
        self.devices = devices 
        self.account_name = account_name 
        self.smsr_oid = smsr_oid 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        devices = None
        if dictionary.get('devices') is not None:
            devices = [DeviceList.from_dictionary(x) for x in dictionary.get('devices')]
        account_name = dictionary.get("accountName") if dictionary.get("accountName") else None
        smsr_oid = dictionary.get("smsrOid") if dictionary.get("smsrOid") else None
        # Return an object of this model
        return cls(devices,
                   account_name,
                   smsr_oid)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'devices={self.devices!r}, '
                f'account_name={self.account_name!r}, '
                f'smsr_oid={self.smsr_oid!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'devices={self.devices!s}, '
                f'account_name={self.account_name!s}, '
                f'smsr_oid={self.smsr_oid!s})')
