# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper


class ReportAsyncAggregateResponse(object):

    """Implementation of the 'Report Async Aggregate Response' model.

    Attributes:
        txid (str): A unique string that associates the request with the
            location report information that is sent in asynchronous callback
            message.ThingSpace will send a separate callback message for each
            device that was in the request. All of the callback messages will
            have the same txid.
        status (AggregatedReportCallbackStatusEnum): The model property of
            type AggregatedReportCallbackStatusEnum.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "txid": 'txid',
        "status": 'status'
    }

    _optionals = [
        'status',
    ]

    def __init__(self,
                 txid=None,
                 status=APIHelper.SKIP):
        """Constructor for the ReportAsyncAggregateResponse class"""

        # Initialize members of the class
        self.txid = txid 
        if status is not APIHelper.SKIP:
            self.status = status 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        txid = dictionary.get("txid") if dictionary.get("txid") else None
        status = dictionary.get("status") if dictionary.get("status") else APIHelper.SKIP
        # Return an object of this model
        return cls(txid,
                   status)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'txid={self.txid!r}, '
                f'status={(self.status if hasattr(self, "status") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'txid={self.txid!s}, '
                f'status={(self.status if hasattr(self, "status") else None)!s})')
