# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.fields_4 import Fields4


class ResourceEvent(object):

    """Implementation of the 'resource.Event' model.

    Attributes:
        accountclientid (str): Not used in this release, future functionality
        callbackurl (str): The URL of the callback listener
        createdon (datetime): Timestamp of the record
        description (str): a short description
        deviceid (str): This is a UUID value of the device created when the
            device is onboarded
        errmsg (str): Error message
        fieldid (str): The model property of type str.
        fields (Fields4): The model property of type Fields4.
        fieldvalue (List[int]): The model property of type List[int].
        foreignid (str): UUID of the ECPD account the user belongs to
        id (str): UUID of the user record, assigned at creation
        lastupdated (datetime): Timestamp of the record
        modelid (str): The model ID of the device
        name (str): User defined name of the record
        sensordataaggregation (bool): A flag to indicate if sensor data is to
            be aggregated (true) or not
        state (str): The current status of the device or transaction and will
            be `success` or `failed`
        transactionid (str): The system-generated UUID of the transaction
        version (str): The resource version
        versionid (str): The UUID of the resource version

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "createdon": 'createdon',
        "fieldid": 'fieldid',
        "foreignid": 'foreignid',
        "lastupdated": 'lastupdated',
        "state": 'state',
        "versionid": 'versionid',
        "accountclientid": 'accountclientid',
        "callbackurl": 'callbackurl',
        "description": 'description',
        "deviceid": 'deviceid',
        "errmsg": 'errmsg',
        "fields": 'fields',
        "fieldvalue": 'fieldvalue',
        "id": 'id',
        "modelid": 'modelid',
        "name": 'name',
        "sensordataaggregation": 'sensordataaggregation',
        "transactionid": 'transactionid',
        "version": 'version'
    }

    _optionals = [
        'accountclientid',
        'callbackurl',
        'description',
        'deviceid',
        'errmsg',
        'fields',
        'fieldvalue',
        'id',
        'modelid',
        'name',
        'sensordataaggregation',
        'transactionid',
        'version',
    ]

    def __init__(self,
                 createdon=None,
                 fieldid=None,
                 foreignid=None,
                 lastupdated=None,
                 state=None,
                 versionid=None,
                 accountclientid=APIHelper.SKIP,
                 callbackurl=APIHelper.SKIP,
                 description=APIHelper.SKIP,
                 deviceid=APIHelper.SKIP,
                 errmsg=APIHelper.SKIP,
                 fields=APIHelper.SKIP,
                 fieldvalue=APIHelper.SKIP,
                 id=APIHelper.SKIP,
                 modelid=APIHelper.SKIP,
                 name=APIHelper.SKIP,
                 sensordataaggregation=APIHelper.SKIP,
                 transactionid=APIHelper.SKIP,
                 version=APIHelper.SKIP):
        """Constructor for the ResourceEvent class"""

        # Initialize members of the class
        if accountclientid is not APIHelper.SKIP:
            self.accountclientid = accountclientid 
        if callbackurl is not APIHelper.SKIP:
            self.callbackurl = callbackurl 
        self.createdon = APIHelper.apply_datetime_converter(createdon, APIHelper.RFC3339DateTime) if createdon else None 
        if description is not APIHelper.SKIP:
            self.description = description 
        if deviceid is not APIHelper.SKIP:
            self.deviceid = deviceid 
        if errmsg is not APIHelper.SKIP:
            self.errmsg = errmsg 
        self.fieldid = fieldid 
        if fields is not APIHelper.SKIP:
            self.fields = fields 
        if fieldvalue is not APIHelper.SKIP:
            self.fieldvalue = fieldvalue 
        self.foreignid = foreignid 
        if id is not APIHelper.SKIP:
            self.id = id 
        self.lastupdated = APIHelper.apply_datetime_converter(lastupdated, APIHelper.RFC3339DateTime) if lastupdated else None 
        if modelid is not APIHelper.SKIP:
            self.modelid = modelid 
        if name is not APIHelper.SKIP:
            self.name = name 
        if sensordataaggregation is not APIHelper.SKIP:
            self.sensordataaggregation = sensordataaggregation 
        self.state = state 
        if transactionid is not APIHelper.SKIP:
            self.transactionid = transactionid 
        if version is not APIHelper.SKIP:
            self.version = version 
        self.versionid = versionid 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        createdon = APIHelper.RFC3339DateTime.from_value(dictionary.get("createdon")).datetime if dictionary.get("createdon") else None
        fieldid = dictionary.get("fieldid") if dictionary.get("fieldid") else None
        foreignid = dictionary.get("foreignid") if dictionary.get("foreignid") else None
        lastupdated = APIHelper.RFC3339DateTime.from_value(dictionary.get("lastupdated")).datetime if dictionary.get("lastupdated") else None
        state = dictionary.get("state") if dictionary.get("state") else None
        versionid = dictionary.get("versionid") if dictionary.get("versionid") else None
        accountclientid = dictionary.get("accountclientid") if dictionary.get("accountclientid") else APIHelper.SKIP
        callbackurl = dictionary.get("callbackurl") if dictionary.get("callbackurl") else APIHelper.SKIP
        description = dictionary.get("description") if dictionary.get("description") else APIHelper.SKIP
        deviceid = dictionary.get("deviceid") if dictionary.get("deviceid") else APIHelper.SKIP
        errmsg = dictionary.get("errmsg") if dictionary.get("errmsg") else APIHelper.SKIP
        fields = Fields4.from_dictionary(dictionary.get('fields')) if 'fields' in dictionary.keys() else APIHelper.SKIP
        fieldvalue = dictionary.get("fieldvalue") if dictionary.get("fieldvalue") else APIHelper.SKIP
        id = dictionary.get("id") if dictionary.get("id") else APIHelper.SKIP
        modelid = dictionary.get("modelid") if dictionary.get("modelid") else APIHelper.SKIP
        name = dictionary.get("name") if dictionary.get("name") else APIHelper.SKIP
        sensordataaggregation = dictionary.get("sensordataaggregation") if "sensordataaggregation" in dictionary.keys() else APIHelper.SKIP
        transactionid = dictionary.get("transactionid") if dictionary.get("transactionid") else APIHelper.SKIP
        version = dictionary.get("version") if dictionary.get("version") else APIHelper.SKIP
        # Return an object of this model
        return cls(createdon,
                   fieldid,
                   foreignid,
                   lastupdated,
                   state,
                   versionid,
                   accountclientid,
                   callbackurl,
                   description,
                   deviceid,
                   errmsg,
                   fields,
                   fieldvalue,
                   id,
                   modelid,
                   name,
                   sensordataaggregation,
                   transactionid,
                   version)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'accountclientid={(self.accountclientid if hasattr(self, "accountclientid") else None)!r}, '
                f'callbackurl={(self.callbackurl if hasattr(self, "callbackurl") else None)!r}, '
                f'createdon={self.createdon!r}, '
                f'description={(self.description if hasattr(self, "description") else None)!r}, '
                f'deviceid={(self.deviceid if hasattr(self, "deviceid") else None)!r}, '
                f'errmsg={(self.errmsg if hasattr(self, "errmsg") else None)!r}, '
                f'fieldid={self.fieldid!r}, '
                f'fields={(self.fields if hasattr(self, "fields") else None)!r}, '
                f'fieldvalue={(self.fieldvalue if hasattr(self, "fieldvalue") else None)!r}, '
                f'foreignid={self.foreignid!r}, '
                f'id={(self.id if hasattr(self, "id") else None)!r}, '
                f'lastupdated={self.lastupdated!r}, '
                f'modelid={(self.modelid if hasattr(self, "modelid") else None)!r}, '
                f'name={(self.name if hasattr(self, "name") else None)!r}, '
                f'sensordataaggregation={(self.sensordataaggregation if hasattr(self, "sensordataaggregation") else None)!r}, '
                f'state={self.state!r}, '
                f'transactionid={(self.transactionid if hasattr(self, "transactionid") else None)!r}, '
                f'version={(self.version if hasattr(self, "version") else None)!r}, '
                f'versionid={self.versionid!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'accountclientid={(self.accountclientid if hasattr(self, "accountclientid") else None)!s}, '
                f'callbackurl={(self.callbackurl if hasattr(self, "callbackurl") else None)!s}, '
                f'createdon={self.createdon!s}, '
                f'description={(self.description if hasattr(self, "description") else None)!s}, '
                f'deviceid={(self.deviceid if hasattr(self, "deviceid") else None)!s}, '
                f'errmsg={(self.errmsg if hasattr(self, "errmsg") else None)!s}, '
                f'fieldid={self.fieldid!s}, '
                f'fields={(self.fields if hasattr(self, "fields") else None)!s}, '
                f'fieldvalue={(self.fieldvalue if hasattr(self, "fieldvalue") else None)!s}, '
                f'foreignid={self.foreignid!s}, '
                f'id={(self.id if hasattr(self, "id") else None)!s}, '
                f'lastupdated={self.lastupdated!s}, '
                f'modelid={(self.modelid if hasattr(self, "modelid") else None)!s}, '
                f'name={(self.name if hasattr(self, "name") else None)!s}, '
                f'sensordataaggregation={(self.sensordataaggregation if hasattr(self, "sensordataaggregation") else None)!s}, '
                f'state={self.state!s}, '
                f'transactionid={(self.transactionid if hasattr(self, "transactionid") else None)!s}, '
                f'version={(self.version if hasattr(self, "version") else None)!s}, '
                f'versionid={self.versionid!s})')
