# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.device_list import DeviceList


class SetFallbackAttributeRequest(object):

    """Implementation of the 'SetFallbackAttributeRequest' model.

    Attributes:
        devices (List[DeviceList]): The model property of type
            List[DeviceList].
        account_name (str): The model property of type str.
        carrier_name (str): The model property of type str.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "devices": 'devices',
        "account_name": 'accountName',
        "carrier_name": 'carrierName'
    }

    _optionals = [
        'carrier_name',
    ]

    def __init__(self,
                 devices=None,
                 account_name=None,
                 carrier_name=APIHelper.SKIP):
        """Constructor for the SetFallbackAttributeRequest class"""

        # Initialize members of the class
        self.devices = devices 
        self.account_name = account_name 
        if carrier_name is not APIHelper.SKIP:
            self.carrier_name = carrier_name 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        devices = None
        if dictionary.get('devices') is not None:
            devices = [DeviceList.from_dictionary(x) for x in dictionary.get('devices')]
        account_name = dictionary.get("accountName") if dictionary.get("accountName") else None
        carrier_name = dictionary.get("carrierName") if dictionary.get("carrierName") else APIHelper.SKIP
        # Return an object of this model
        return cls(devices,
                   account_name,
                   carrier_name)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'devices={self.devices!r}, '
                f'account_name={self.account_name!r}, '
                f'carrier_name={(self.carrier_name if hasattr(self, "carrier_name") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'devices={self.devices!s}, '
                f'account_name={self.account_name!s}, '
                f'carrier_name={(self.carrier_name if hasattr(self, "carrier_name") else None)!s})')
