# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.accountidentifier_1 import Accountidentifier1
from verizon.models.resourceidentifier_1 import Resourceidentifier1


class TargetsActionsQueryRequest(object):

    """Implementation of the 'Targets Actions Query Request' model.

    Attributes:
        accountidentifier (Accountidentifier1): The model property of type
            Accountidentifier1.
        selection (Dict[str, str]): A comma-separated list of properties and
            comparator values to match against subscriptions in the ThingSpace
            account. See Working with Query Filters for more information. If
            the request does not include `$selection`, the response will
            include all subscriptions to which the requesting user has access.
        resourceidentifier (Resourceidentifier1): The model property of type
            Resourceidentifier1.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "accountidentifier": 'accountidentifier',
        "selection": '$selection',
        "resourceidentifier": 'resourceidentifier'
    }

    _optionals = [
        'accountidentifier',
        'selection',
        'resourceidentifier',
    ]

    def __init__(self,
                 accountidentifier=APIHelper.SKIP,
                 selection=APIHelper.SKIP,
                 resourceidentifier=APIHelper.SKIP):
        """Constructor for the TargetsActionsQueryRequest class"""

        # Initialize members of the class
        if accountidentifier is not APIHelper.SKIP:
            self.accountidentifier = accountidentifier 
        if selection is not APIHelper.SKIP:
            self.selection = selection 
        if resourceidentifier is not APIHelper.SKIP:
            self.resourceidentifier = resourceidentifier 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        accountidentifier = Accountidentifier1.from_dictionary(dictionary.get('accountidentifier')) if 'accountidentifier' in dictionary.keys() else APIHelper.SKIP
        selection = dictionary.get("$selection") if dictionary.get("$selection") else APIHelper.SKIP
        resourceidentifier = Resourceidentifier1.from_dictionary(dictionary.get('resourceidentifier')) if 'resourceidentifier' in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(accountidentifier,
                   selection,
                   resourceidentifier)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'accountidentifier={(self.accountidentifier if hasattr(self, "accountidentifier") else None)!r}, '
                f'selection={(self.selection if hasattr(self, "selection") else None)!r}, '
                f'resourceidentifier={(self.resourceidentifier if hasattr(self, "resourceidentifier") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'accountidentifier={(self.accountidentifier if hasattr(self, "accountidentifier") else None)!s}, '
                f'selection={(self.selection if hasattr(self, "selection") else None)!s}, '
                f'resourceidentifier={(self.resourceidentifier if hasattr(self, "resourceidentifier") else None)!s})')
