# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.anomaly_trigger_request_1 import AnomalyTriggerRequest1
from verizon.models.data_trigger_request import DataTriggerRequest
from verizon.models.promo_alert_trigger_request import PromoAlertTriggerRequest
from verizon.models.session_trigger_request import SessionTriggerRequest
from verizon.models.sms_trigger_request import SMSTriggerRequest


class UpdateTriggerRequest(object):

    """Implementation of the 'UpdateTriggerRequest' model.

    Attributes:
        account_name (str): The model property of type str.
        active (bool): The model property of type bool.
        anomaly_trigger_request (AnomalyTriggerRequest1): The model property
            of type AnomalyTriggerRequest1.
        cycle_type (CycleTypeEnum): The model property of type CycleTypeEnum.
        data_trigger_request (DataTriggerRequest): The model property of type
            DataTriggerRequest.
        group_name (str): The model property of type str.
        promo_alert_trigger_request (PromoAlertTriggerRequest): The model
            property of type PromoAlertTriggerRequest.
        session_trigger_request (SessionTriggerRequest): The model property of
            type SessionTriggerRequest.
        sms_trigger_request (SMSTriggerRequest): The model property of type
            SMSTriggerRequest.
        trigger_category (str): The model property of type str.
        trigger_id (str): The model property of type str.
        trigger_name (str): The model property of type str.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "account_name": 'accountName',
        "active": 'active',
        "anomaly_trigger_request": 'anomalyTriggerRequest',
        "cycle_type": 'cycleType',
        "data_trigger_request": 'dataTriggerRequest',
        "group_name": 'groupName',
        "promo_alert_trigger_request": 'promoAlertTriggerRequest',
        "session_trigger_request": 'sessionTriggerRequest',
        "sms_trigger_request": 'smsTriggerRequest',
        "trigger_category": 'triggerCategory',
        "trigger_id": 'triggerId',
        "trigger_name": 'triggerName'
    }

    _optionals = [
        'account_name',
        'active',
        'anomaly_trigger_request',
        'cycle_type',
        'data_trigger_request',
        'group_name',
        'promo_alert_trigger_request',
        'session_trigger_request',
        'sms_trigger_request',
        'trigger_category',
        'trigger_id',
        'trigger_name',
    ]

    def __init__(self,
                 account_name=APIHelper.SKIP,
                 active=APIHelper.SKIP,
                 anomaly_trigger_request=APIHelper.SKIP,
                 cycle_type=APIHelper.SKIP,
                 data_trigger_request=APIHelper.SKIP,
                 group_name=APIHelper.SKIP,
                 promo_alert_trigger_request=APIHelper.SKIP,
                 session_trigger_request=APIHelper.SKIP,
                 sms_trigger_request=APIHelper.SKIP,
                 trigger_category=APIHelper.SKIP,
                 trigger_id=APIHelper.SKIP,
                 trigger_name=APIHelper.SKIP):
        """Constructor for the UpdateTriggerRequest class"""

        # Initialize members of the class
        if account_name is not APIHelper.SKIP:
            self.account_name = account_name 
        if active is not APIHelper.SKIP:
            self.active = active 
        if anomaly_trigger_request is not APIHelper.SKIP:
            self.anomaly_trigger_request = anomaly_trigger_request 
        if cycle_type is not APIHelper.SKIP:
            self.cycle_type = cycle_type 
        if data_trigger_request is not APIHelper.SKIP:
            self.data_trigger_request = data_trigger_request 
        if group_name is not APIHelper.SKIP:
            self.group_name = group_name 
        if promo_alert_trigger_request is not APIHelper.SKIP:
            self.promo_alert_trigger_request = promo_alert_trigger_request 
        if session_trigger_request is not APIHelper.SKIP:
            self.session_trigger_request = session_trigger_request 
        if sms_trigger_request is not APIHelper.SKIP:
            self.sms_trigger_request = sms_trigger_request 
        if trigger_category is not APIHelper.SKIP:
            self.trigger_category = trigger_category 
        if trigger_id is not APIHelper.SKIP:
            self.trigger_id = trigger_id 
        if trigger_name is not APIHelper.SKIP:
            self.trigger_name = trigger_name 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        account_name = dictionary.get("accountName") if dictionary.get("accountName") else APIHelper.SKIP
        active = dictionary.get("active") if "active" in dictionary.keys() else APIHelper.SKIP
        anomaly_trigger_request = AnomalyTriggerRequest1.from_dictionary(dictionary.get('anomalyTriggerRequest')) if 'anomalyTriggerRequest' in dictionary.keys() else APIHelper.SKIP
        cycle_type = dictionary.get("cycleType") if dictionary.get("cycleType") else APIHelper.SKIP
        data_trigger_request = DataTriggerRequest.from_dictionary(dictionary.get('dataTriggerRequest')) if 'dataTriggerRequest' in dictionary.keys() else APIHelper.SKIP
        group_name = dictionary.get("groupName") if dictionary.get("groupName") else APIHelper.SKIP
        promo_alert_trigger_request = PromoAlertTriggerRequest.from_dictionary(dictionary.get('promoAlertTriggerRequest')) if 'promoAlertTriggerRequest' in dictionary.keys() else APIHelper.SKIP
        session_trigger_request = SessionTriggerRequest.from_dictionary(dictionary.get('sessionTriggerRequest')) if 'sessionTriggerRequest' in dictionary.keys() else APIHelper.SKIP
        sms_trigger_request = SMSTriggerRequest.from_dictionary(dictionary.get('smsTriggerRequest')) if 'smsTriggerRequest' in dictionary.keys() else APIHelper.SKIP
        trigger_category = dictionary.get("triggerCategory") if dictionary.get("triggerCategory") else APIHelper.SKIP
        trigger_id = dictionary.get("triggerId") if dictionary.get("triggerId") else APIHelper.SKIP
        trigger_name = dictionary.get("triggerName") if dictionary.get("triggerName") else APIHelper.SKIP
        # Return an object of this model
        return cls(account_name,
                   active,
                   anomaly_trigger_request,
                   cycle_type,
                   data_trigger_request,
                   group_name,
                   promo_alert_trigger_request,
                   session_trigger_request,
                   sms_trigger_request,
                   trigger_category,
                   trigger_id,
                   trigger_name)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'account_name={(self.account_name if hasattr(self, "account_name") else None)!r}, '
                f'active={(self.active if hasattr(self, "active") else None)!r}, '
                f'anomaly_trigger_request={(self.anomaly_trigger_request if hasattr(self, "anomaly_trigger_request") else None)!r}, '
                f'cycle_type={(self.cycle_type if hasattr(self, "cycle_type") else None)!r}, '
                f'data_trigger_request={(self.data_trigger_request if hasattr(self, "data_trigger_request") else None)!r}, '
                f'group_name={(self.group_name if hasattr(self, "group_name") else None)!r}, '
                f'promo_alert_trigger_request={(self.promo_alert_trigger_request if hasattr(self, "promo_alert_trigger_request") else None)!r}, '
                f'session_trigger_request={(self.session_trigger_request if hasattr(self, "session_trigger_request") else None)!r}, '
                f'sms_trigger_request={(self.sms_trigger_request if hasattr(self, "sms_trigger_request") else None)!r}, '
                f'trigger_category={(self.trigger_category if hasattr(self, "trigger_category") else None)!r}, '
                f'trigger_id={(self.trigger_id if hasattr(self, "trigger_id") else None)!r}, '
                f'trigger_name={(self.trigger_name if hasattr(self, "trigger_name") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'account_name={(self.account_name if hasattr(self, "account_name") else None)!s}, '
                f'active={(self.active if hasattr(self, "active") else None)!s}, '
                f'anomaly_trigger_request={(self.anomaly_trigger_request if hasattr(self, "anomaly_trigger_request") else None)!s}, '
                f'cycle_type={(self.cycle_type if hasattr(self, "cycle_type") else None)!s}, '
                f'data_trigger_request={(self.data_trigger_request if hasattr(self, "data_trigger_request") else None)!s}, '
                f'group_name={(self.group_name if hasattr(self, "group_name") else None)!s}, '
                f'promo_alert_trigger_request={(self.promo_alert_trigger_request if hasattr(self, "promo_alert_trigger_request") else None)!s}, '
                f'session_trigger_request={(self.session_trigger_request if hasattr(self, "session_trigger_request") else None)!s}, '
                f'sms_trigger_request={(self.sms_trigger_request if hasattr(self, "sms_trigger_request") else None)!s}, '
                f'trigger_category={(self.trigger_category if hasattr(self, "trigger_category") else None)!s}, '
                f'trigger_id={(self.trigger_id if hasattr(self, "trigger_id") else None)!s}, '
                f'trigger_name={(self.trigger_name if hasattr(self, "trigger_name") else None)!s})')
