# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper


class WNPRestErrorResponse(object):

    """Implementation of the 'WNPRestErrorResponse' model.

    Wireless network performance rest error response.

    Attributes:
        error_code (str): Rest error response.
        error_message (str): Error message details.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "error_code": 'errorCode',
        "error_message": 'errorMessage'
    }

    _optionals = [
        'error_code',
        'error_message',
    ]

    def __init__(self,
                 error_code=APIHelper.SKIP,
                 error_message=APIHelper.SKIP):
        """Constructor for the WNPRestErrorResponse class"""

        # Initialize members of the class
        if error_code is not APIHelper.SKIP:
            self.error_code = error_code 
        if error_message is not APIHelper.SKIP:
            self.error_message = error_message 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        error_code = dictionary.get("errorCode") if dictionary.get("errorCode") else APIHelper.SKIP
        error_message = dictionary.get("errorMessage") if dictionary.get("errorMessage") else APIHelper.SKIP
        # Return an object of this model
        return cls(error_code,
                   error_message)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'error_code={(self.error_code if hasattr(self, "error_code") else None)!r}, '
                f'error_message={(self.error_message if hasattr(self, "error_message") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'error_code={(self.error_code if hasattr(self, "error_code") else None)!s}, '
                f'error_message={(self.error_message if hasattr(self, "error_message") else None)!s})')
